#!/bin/sh
# omupdate.sh
#
# this is a skeleton template for the graphics-engine
# logging driver.  It should eventually be generated by
# configure.pl.
#
# called by crontab once per minute

# these may change - logical params
BASEDIR=/home/mrourmon
FLOWSIZE=10000000
UDPWEIGHT=10000000
#turn on if wget used with probe to fetch 4 probe output files
#WGET=/usr/local/bin/wget
#PROBE=10.0.0.1

#################################################### 
# everthing else is derived from BASEDIR
BINDIR=$BASEDIR/bin
RRDDATA=$BASEDIR/rrddata
# we assume this is a symlink to the real web directory
WEBDIR=$BASEDIR/web.pages
LOGDIR=$BASEDIR/logs
TMPDIR=$BASEDIR/tmp

# input files
# position of probe outputs, inputs for graphics-engine
MONLITE=$TMPDIR/mon.lite
TCPWORM=$TMPDIR/tcpworm.txt
P2PFILE=$TMPDIR/p2pfile.txt
IRCFILE=$TMPDIR/irc.txt

# do twice, once per 30 seconds
for i in 1 2
do

# first get all the files from the probe

#$WGET -q --output-document=$MONLITE http://$PROBE/mon.lite
#$WGET -q --output-document=$TCPWORM http://$PROBE/tcpworm.txt
#$WGET -q --output-document=$P2PFILE http://$PROBE/p2pfile.txt
#$WGET -q --output-document=$IRCFILE http://$PROBE/irc.txt

# LOG tworm 
# backup of tcpworm.txt to logs/tworm directory
$BINDIR/monbackup.pl $TCPWORM $LOGDIR/tworm
# LOG backup of mon.lite to logs/mon.lite directory
$BINDIR/monbackup.pl $MONLITE $LOGDIR/mon.lite


# LOG daily/topn_log dirs
# run omupdate.pl graph/report maker with appropriate parameters
$BINDIR/omupdate.pl -m $MONLITE -t $BINDIR/drawtopn -w $WEBDIR -r $RRDDATA -l $LOGDIR -a $FLOWSIZE -u $UDPWEIGHT -e $WEBDIR/event_today.txt
ETIME=$?

# LOG udpreport
# udpreport.txt is made as a side effect of the omupdate.pl run.
# if udpreport.txt exists, copy it to a log directory
if [ -f $WEBDIR/udpreport.txt ]; then
	$BINDIR/monbackup.pl $WEBDIR/udpreport.txt $LOGDIR/udpreport
fi

# run tcpworm.pl with the appropriate parameters
$BINDIR/tcpworm.pl  -E $WEBDIR/newportsig_today.txt -p $WEBDIR/portreport.txt  -D $LOGDIR/topn_today/scanner $TCPWORM > $WEBDIR/tcpworm.txt

# LOG portreport
# use monbackup.pl to backup the portreport.txt output file
$BINDIR/monbackup.pl $WEBDIR/portreport.txt $LOGDIR/portreport

# run tcpworm.pl again to produce p2p-based portreport with app flags in it
$BINDIR/tcpworm.pl  -p $WEBDIR/p2pportreport.txt  $P2PFILE > $WEBDIR/p2pfile.txt
TTIME=$?

# LOG p2p files raw and processed
$BINDIR/monbackup.pl $P2PFILE $LOGDIR/rawp2p
$BINDIR/monbackup.pl $WEBDIR/p2pportreport.txt $LOGDIR/p2preport

# run topipa.pl here eventually

# LOG daily/syn_worm.log
# convert the tcpworm.txt file into a log entry for batch processing later on
# this is gross thing and should go away eventually.
$BINDIR/wormtolog.pl $TCPWORM  $LOGDIR  syn_worm.log

# LOG irc
# now do irc report and backup of output
$BINDIR/irc.pl -f $IRCFILE > $WEBDIR/ircreport.txt
$BINDIR/monbackup.pl $WEBDIR/ircreport.txt $LOGDIR/irc
# LOG rawirc
$BINDIR/monbackup.pl $IRCFILE $LOGDIR/rawirc

# xxx - we need to make a sync daemon
# make up for elapsed time spent in omupdate.pl and possibly tcpworm.pl
case $i in
1)
	ETIME=`expr $ETIME + $TTIME`
 	STIME=`expr 30 - $ETIME`
	sleep $STIME
	;;
2)
	;;
esac

# end for
done
